<p>U prethodnoj minilekciji napisali smo model toka podataka sklopa <em>sklop1</em>. Sučelje ovog sklopa 
   prikazano je na slici 1.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop1i.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Sučelje sklopa <em>sklop1</em>.</figcaption>
</figure>

<p>Logička shema ovog sklopa na temelju koje smo napisali model toka podataka prikazana je na slici 2.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop1orig.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Logička shema sklopa <em>sklop1</em>.</figcaption>
</figure>

<p>Prisjetimo se: prvi korak pri izradi modela toka podataka jest odrediti logičke izraze koji opisuju
   na koji se način ulazi sklopa transformiraju u izlazne vrijednosti. Analizom sheme prikazane na slici 2
   došli smo do sljedećih izraza:<br>
   \(f = a \cdot b\)<br>
   \(g = b \cdot (a+c)\)<br>
   Ovaj posljednji izraz, oslanjajući se na aksiome i teoreme Booleove algebre, možemo zapisati i malo 
   drugačije:<br>
   \(g = a \cdot b + b \cdot c\).</p>

<p>Uzmimo stoga kao "radne" izraze sljedeća dva izraza:<br>
   \(f = a \cdot b\)<br>
   \(g = a \cdot b + b \cdot c\).<br>
   Primjećujemo da se \( a \cdot b \) pojavljuje u oba izraza pa ćemo ga sklopovski ostvariti samo jednom.
   Logička shema koja prikazuje ovakvo ostvarenje dana je na slici 3.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop1.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 3.</span> Ekvivalentna logička shema sklopa <em>sklop1</em>.</figcaption>
</figure>

<p>Pri izradi modela toka podataka možemo se poslužiti pristupom kod kojega za svaki izlaz pišemo jednu naredbu
   pridruživanja u tijelu arhitekture i ništa više. Međutim, opis možemo raditi i detaljnije, opisujući
   transformaciju ulaza u izlaze postupno. U tom smislu primijetite da na slici 3 imamo 3 vrste "žica"
   kako je opisano u nastavku.
</p>
<ol>
  <li>Žice koje ulaze dovode do ulaza logičkih sklopova. U VHDL-u, njih u logičkim izrazima prikazujemo
      navođenjem naziva pripadnog ulaza sklopa (u našem slučaju: <code>a</code>, <code>b</code> 
      i <code>c</code>).</li>
  <li>Žice koje vrijednosti generirane na izlazu nekog logičkog sklopa odvode izravno na izlaz modeliranog
      sklopa. U VHDL-u, njih prikazujemo navođenjem naziva pripadnog izlaza sklopa (u našem slučaju: 
      <code>f</code> i <code>g</code>).</li>
  <li>Konačno, primijetite da u shemi na slici 3 postoji žica koja ne dovodi niti jednu ulaznu vrijednost
      te ne odvodi vrijednost na izlaz modeliranog sklopa: radi se o žici koja izlaz logičkog sklopa I
      koji računa \(b \cdot c\) dovodi na donji ulaz sklopa ILI. Takve žice ne čine dio sučelja sklopa
      (nisu njegovi ulazi niti izlazi) i korisnik sklopa, kada isti promatra kao crnu kutiju, nije svjestan
      njihovog postojanja. Upravo iz tog razloga, takve žice nazivamo <em>internim signalima</em>. Interni
      signali slični su portovima koje definiramo u sučelju - jedina je razlika što nemaju smjera 
      (<code>IN</code> ili <code>OUT</code>) i ne deklariraju se u sučelju sklopa već u deklaracijskom dijelu
      arhitekture sklopa (dakle prije navođenja ključne riječi <code>BEGIN</code>).</li>
</ol>

<p>Slika 4 prikazuje logičku shemu koja dodatno ima označen (imenovan) spomenuti interni signal. Dali smo mu ime
   <code>s1</code>.</p>

<figure class="mlFigure">
<img src="@#file#(sklop1a1.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 4.</span> Ekvivalentna logička shema sklopa <em>sklop1</em> uz obilježen interni signal <code>s1</code>.</figcaption>
</figure>

<p>Interni signali deklariraju se navođenjem ključne riječi <code>SIGNAL</code> nakon čega slijedi zarezima
   odvojena lista imena internih signala, nakon toga slijedi znak dvotočke, potom specifikacija podatkovnog 
   tipa internog signala, opcionalna inicijalizacija vrijednosti (za sada ćemo je preskočiti) i na kraju
   znak točka-zareza. Evo nekoliko primjera definiranja internih signala:</p>
   <pre><code>SIGNAL x: std_logic;
SIGNAL y,z,w: std_logic;</code></pre>

<p>Ako imamo više internih signala i svi su različitog tipa, za svaki ćemo pisati po jednu deklaraciju.
   Ako imamo više internih signala koji dijele podatkovni tip, možemo za svaki pisati po jednu deklaraciju
   ili se možemo poslužiti mogućnošću da u jednoj deklaraciji predamo popis imena.</p>

<p>Model toka podataka sklopa <em>sklop1</em> napisat ćemo temeljeći se na sljedećim logičkim izrazima 
   (gledajte shemu na slici 4):<br>
   \( f = a \cdot b \)<br>
   \( s1 = b \cdot c \)<br>
   \( g = f + s1 \)<br>
   Pripadni VHDL-kod prikazan je u nastavku.</p>

<pre><code>library ieee;
use ieee.std_logic_1164.all;

ENTITY sklop1 IS PORT (
  a, b, c: IN std_logic;
  f, g: OUT std_logic
);
END sklop1;

ARCHITECTURE arch1 OF sklop1 IS
  SIGNAL s1: std_logic;
BEGIN
  f &lt;= a AND b;
  s1 &lt;= b AND c;
  g &lt;= f OR s1;
END arch1;</code></pre>

<p>Primijetite kako smo u deklaracijskom dijelu arhitekture (prije ključne riječi <code>BEGIN</code> kojom započinje
   tijelo arhitekture) deklarirali interni signal <code>s1</code>. Potom smo u arhitekturi napisali
   naredbe dodjeljivanja: jednu koja modelira osnovni logički sklop koji računa vrijednost izlaza <code>f</code>,
   jednu koja modelira osnovni logički sklop koji računa vrijednost internog signala <code>s1</code> i konačno
   jednu koja modelira osnovni logički sklop koji računa vrijednost izlaza <code>g</code> na temelju internog
   signala.</p>

<p>Napisana specifikacija, nažalost, ima problem: <strong>nije ispravna</strong> i ne da se prevesti.</p>

<p>Naredba dodjeljivanja kojom smo definirali vrijednost za izlaz <code>f</code> ovisi o ulazima
   <code>a</code> i <code>b</code>: kad god se vrijednosti na bilo kojem od tih ulaza promijene, 
   moglo bi doći do promjene vrijednosti koja se šalje u izlaz <code>f</code>; za ulaze 
   <code>a</code> i <code>b</code> stoga kažemo (zapamtite pojam!) da čine <em>implicitnu listu
   osjetljivosti</em> tog izraza.</p>

<p>Naredba dodjeljivanja kojom smo definirali vrijednost za interni signal <code>s1</code> ovisi o ulazima
   <code>b</code> i <code>c</code>: oni čine njezinu implicitnu listu osjetljivosti.</p>

<p>Konačno, naredba dodjeljivanja kojom smo definirali vrijednost za izlaz <code>g</code> ovisi o izlazu
   <code>f</code> i internom signalu <code>s1</code>: oni čine njezinu implicitnu listu osjetljivosti.
   I na ovom mjestu nastupa problem: <strong>izlazi</strong> ne mogu biti u listama osjetljivosti jer su,
   kao što im samo ime kaže - izlazi, pa im se u VHDL-u vrijednost može samo zapisivati ali ne može čitati,
   a izraz koji određuje vrijednost izlaza <code>g</code> mora moći pročitati što je na izlazu <code>f</code>
   kako bi izračunao što treba postaviti na izlaz <code>g</code>.
</p>

<div class="mlImportant">
 <p>U logičkim izrazima (tj. na desnoj strani operatora dodjeljivanja vrijednosti) ne mogu se pojavljivati
    izlazni portovi sklopa (signali koji su u sučelju sklopa definirani kao <code>OUT</code>).</p>
 <p>Ako se nađete u takvoj situaciji, uvedite pomoćni interni signal!</p>
</div>

<p>Kako ćemo riješiti ovaj problem? U interne signale vrijednosti možemo zapisivati, ali ih možemo i čitati. 
   Stoga ćemo uvesti još jedan interni signal, kako je prikazano na slici 5.</p>

<figure class="mlFigure">
<img src="@#file#(sklop1a2.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 5.</span> Logička shema sklopa <em>sklop1</em> uz obilježene sve potrebne interne signale (<code>s1</code> i <code>s2</code>).</figcaption>
</figure>

<p>Primijetite: gornji logički sklop generira vrijednost za interni signal <code>s2</code>. U logičkom smislu,
   naš je sklop sada opisan sljedećim izrazima:<br>
   \( s2 = a \cdot b \)<br>
   \( s1 = b \cdot c \)<br>
   \( f = s2 \)<br>
   \( g = s2 + s1 \)<br>
   Pripadni VHDL-kod, a to je ujedno i konačan i ispravan opis sklopa, prikazan je u nastavku.</p>

<pre><code>library ieee;
use ieee.std_logic_1164.all;

ENTITY sklop1 IS PORT (
  a, b, c: IN std_logic;
  f, g: OUT std_logic
);
END sklop1;

ARCHITECTURE arch1 OF sklop1 IS
  SIGNAL s1: std_logic;
  SIGNAL s2: std_logic;
BEGIN
  s2 &lt;= a AND b;
  s1 &lt;= b AND c;
  f &lt;= s2;
  g &lt;= s2 OR s1;
END arch1;</code></pre>

<p>Umjesto zasebnih deklaracija internih signala <code>s1</code> i <code>s2</code>, isto smo mogli napisati
   i samo jednom deklaracijom:</p>

<pre><code>  SIGNAL s1, s2: std_logic;</code></pre>

<div class="mlNote">
 <p>Prisjetimo se: sve naredbe napisane u tijelu arhitekture izvode se istovremeno i njihov međusobni poredak
    nije bitan. Stoga smo naredbe u tijelu arhitekture mogli poredati primjerice i ovako:</p>
<pre><code>  f &lt;= s2;
  g &lt;= s2 OR s1;
  s1 &lt;= b AND c;
  s2 &lt;= a AND b;</code></pre>
</div>

